#include "Adafruit_Keypad.h"            //Downlaod library here: https://electronoobs.com/eng_Arduino_Adafruit_Keypad.php
#include <Wire.h>
#include <LiquidCrystal_I2C.h>          //Download it here: https://www.electronoobs.com/eng_arduino_liq_crystal.php
LiquidCrystal_I2C lcd(0x3f,16,2);       //slave address sometimes can be 0x3f or 0x27. Try both!


const byte ROWS = 4; // rows            //Number of rows your keypad has
const byte COLS = 4; // columns         //Number of columns your keypad has
/* Define the symbols on the buttons of the keypads. This could bea ny other symbol. 
   For example, if when I press the "1! button you want to print a '?' just change 
   the '1' below with a '?'*/
char keys[ROWS][COLS] = {
  {'1','2','3','A'},
  {'4','5','6','B'},
  {'7','8','9','C'},
  {'*','0','#','D'}
};

byte rowPins[ROWS] = {9, 8, 7, 6};    //connect to the row pinouts of the keypad (as in example schematic)
byte colPins[COLS] = {5, 4, 3, 2};    //connect to the column pinouts of the keypad (as in example schematic)

//initialize an instance of class NewKeypad
Adafruit_Keypad customKeypad = Adafruit_Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS);

void setup() {
  Serial.begin(9600);         //Start serial communication with the LCD (for serial monitor)
  delay(10);
  lcd.init();                 //Start i2c communication with the LCD
  lcd.backlight();            //Activate backlight
}

void loop() {
  // put your main code here, to run repeatedly:
  customKeypad.tick();

  while(customKeypad.available()){
    keypadEvent e = customKeypad.read();
    Serial.print((char)e.bit.KEY);        //Print character on serial monitor
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print((char)e.bit.KEY);           //Print character on LCD
  
    if(e.bit.EVENT == KEY_JUST_PRESSED){
      Serial.println(" pressed");
    }
    else if(e.bit.EVENT == KEY_JUST_RELEASED){
      Serial.println(" released");
    }
  }

  delay(10);
}
